# **********************************************************************
# Copyright 2015 VMware, Inc.  All rights reserved. VMware Confidential.
# **********************************************************************
# $Id$
# $DateTime$
# $Change$
# $Author$
# **********************************************************************


class Bridge(object):
    def __init__(self, **kwargs):
        prop_defaults = {
            "ref_count": None,
            "bridge_network_num": None,
            "name": None,
            "bridge_id": None,
            "ps_name": None,
            "dvs_name": None,
            "num_uplinks": None,
            "port_not_exist": None,
            "ageing_time": None,
            "fdb_hold_time": None,
            "fdb_hit": None,
            "fdb_learn": None,
            "fdb_update": None,
            "fdb_table_full": None,
            "fdb_chain": None,
            "fdb_aged": None,
            "fdb_mac_moved": None,
            "fdb_mac_hit": None,
            "fdb_forwarded": None,
            "fdb_miss": None}
        for (prop, default) in list(prop_defaults.items()):
            setattr(self, prop, kwargs.get(prop, default))

    def json_repr(self):
        return self.__dict__


class BridgeNetwork(object):
    def __init__(self, **kwargs):
        prop_defaults = {
            "ref_count": None,
            "network_type": None,
            "vlan_id": None,
            "vxlan_id": None,
            "bridge_port_num": None,
            "ageing_time": None,
            "fdb_hold_time": None,
            "FRP_filter": None,
            "fdb_hit": None,
            "fdb_learn": None,
            "fdb_update": None,
            "fdb_table_full": None,
            "fdb_chain": None,
            "fdb_aged": None,
            "fdb_mac_moved": None,
            "fdb_mac_hit": None,
            "FRP_filter_leaf_tx": None,
            "FRP_filter_bridged": None,
            "fdb_uplink_filter": None,
            "fdb_forwarded": None,
            "fdb_miss": None,
            "bridge_ports": None,
            "name": None}
        for (prop, default) in list(prop_defaults.items()):
            setattr(self, prop, kwargs.get(prop, default))

    def json_repr(self):
        return self.__dict__


class BridgePort(object):
    def __init__(self, **kwargs):
        prop_defaults = {
            "ref_count": None,
            "port_id": None,
            "vlan_id": None,
            "IOChain_installed": None,
            "pkts_tx": None,
            "bytes_tx": None,
            "pkts_tx_multicast": None,
            "pkts_tx_broadcast": None,
            "pkts_rx": None,
            "bytes_rx": None,
            "pkts_rx_multicast": None,
            "pkts_rx_broadcast": None,
            "dropped_tx": None,
            "dropped_rx": None,
            "mapped_len_too_short": None,
            "pkts_bridged": None,
            "pkts_dropped_bridged": None,
            "pkts_dropped_uplink": None,
            "dropped_tx_port_mismatch": None,
            "dropped_tx_vxlan_pkt_to_vlan": None}
        for (prop, default) in list(prop_defaults.items()):
            setattr(self, prop, kwargs.get(prop, default))

    def json_repr(self):
        return self.__dict__


class BridgeFdb(object):
    def __init__(self, **kwargs):
        prop_defaults = {
            "mac": None,
            "vlan_id": None,
            "vxlan_id": None,
            "flags": None,
            "age": None,
            "port_id": None}
        for (prop, default) in list(prop_defaults.items()):
            setattr(self, prop, kwargs.get(prop, default))

    def json_repr(self):
        return self.__dict__


class LogicalRouterNeighbor(object):
    def __init__(self, **kwargs):
        prop_defaults = {
            "ip": None,
            "mac": None,
            "flags": None,
            "expiry": None,
            "source_port_id": None,
            "refcnt": None,
            "lif_name": None,
            "address_type": None}
        for (prop, default) in list(prop_defaults.items()):
            setattr(self, prop, kwargs.get(prop, default))

    def json_repr(self):
        return self.__dict__
