# Copyright (C) 2019 VMware, Inc. All rights reserved.
# -- VMware Confidential
from abc import ABCMeta, abstractmethod


class Action(metaclass=ABCMeta):
    """The parent class of all actions, each action need to implement the `do` method.
    """
    _logger = None

    @classmethod
    @abstractmethod
    def do(cls, hub, *args): pass
